/*
 * "Peko" Visual Novel System
 *
 * All Rights Reserved.
 * Copyright (c) 1999-2003 Tsukuba Bunko.
 *
 * $Id: SaveFailureException.java,v 1.1.2.1 2003/12/11 10:12:19 ppoi Exp $
 */
package tsukuba_bunko.peko.session;

import	java.io.PrintStream;
import	java.io.PrintWriter;


/**
 * セーブが失敗したことを通知する例外です。
 * @author	$Author: ppoi $
 * @version	$Revision: 1.1.2.1 $
 */
public class SaveFailureException	extends Exception	{

	/**
	 * 基になる例外オブジェクト
	 */
	private Throwable	_base = null;


	/**
	 * <code>SaveFailureException</code> のインスタンスを作成します。
	 */
	public SaveFailureException()
	{
		super();
	}

	/**
	 * <code>SaveFailureException</code> のインスタンスを作成します。
	 * @param	message	エラーメッセージ
	 */
	public SaveFailureException( String message )
	{
		super( message );
	}

	/**
	 * <code>SaveFailureException</code> のインスタンスを作成します。
	 * @param	e	基になる例外オブジェクト
	 */
	public SaveFailureException( Throwable e )
	{
		super( e.getMessage() );
		_base = e;
	}

	/**
	 * <code>SaveFailureException</code> のインスタンスを作成します。
	 * @param	message	エラーメッセージ
	 * @param	e	基になる例外オブジェクト
	 */
	public SaveFailureException( String message, Throwable e )
	{
		super( message );
		_base = e;
	}


//
//	Throwable の実装
//
	public void printStackTrace()
	{
		super.printStackTrace();
		if( _base != null )	{
			System.err.println( "source exception: " + _base.getClass().getName() );
			_base.printStackTrace();
		}
	}

	public void printStackTrace( PrintStream ps )
	{
		super.printStackTrace( ps );
		if( _base != null )	{
			ps.println( "source exception: " + _base.getClass().getName() );
			_base.printStackTrace( ps );
		}
	}

	public void printStackTrace( PrintWriter pw )
	{
		super.printStackTrace();
		if( _base != null )	{
			pw.println( "source exception: " + _base.getClass().getName() );
			_base.printStackTrace( pw );
		}
	}
}
